田草博客
日志搜索


 标题   内容 评论


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号 ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件
-电信用户-|-网通用户-
-博客论坛-|-软件下载-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2019 - 9 48
1234567
891011121314
15161718192021
22232425262728
2930


站点统计

最新评论



参照块在位编辑的时候不能保存的问题 怎样实现鼠标悬停时显示Xdata中的内容
未知 Adding XData to AutoCAD entities using .NET   [ 日期:2016-10-10 ]   [ 来自:本站原创 ]  HTML
使用VB.net 为AutoCAD实体添加扩展数据

Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.Runtime

Namespace ExtendedEntityData
    Public Class Commands
        <CommandMethod("GXD")> _
        Public Shared Sub GetXData()
            Dim doc As Document = Application.DocumentManager.MdiActiveDocument
            Dim ed As Editor = doc.Editor

            ' Ask the user to select an entity
            ' for which to retrieve XData
            Dim opt As New PromptEntityOptions(vbLf & "Select entity: ")
            Dim res As PromptEntityResult = ed.GetEntity(opt)

            If res.Status = PromptStatus.OK Then
                Dim tr As Transaction = doc.TransactionManager.StartTransaction()
                Using tr
                    Dim obj As DBObject = tr.GetObject(res.ObjectId, OpenMode.ForRead)
                    Dim rb As ResultBuffer = obj.XData
                    If rb Is Nothing Then
                        ed.WriteMessage(vbLf & "Entity does not have XData attached.")
                    Else
                        Dim n As Integer = 0
                        For Each tv As TypedValue In rb
                            ed.WriteMessage(vbLf & "TypedValue {0} - type: {1}, value: {2}", System.Math.Max(System.Threading.Interlocked.Increment(n), n - 1), tv.TypeCode, tv.Value)
                        Next
                        rb.Dispose()
                    End If
                End Using
            End If
        End Sub

        <CommandMethod("SXD")> _
        Public Shared Sub SetXData()
            Dim doc As Document = Application.DocumentManager.MdiActiveDocument
            Dim ed As Editor = doc.Editor

            ' Ask the user to select an entity
            ' for which to set XData
            Dim opt As New PromptEntityOptions(vbLf & "Select entity: ")
            Dim res As PromptEntityResult = ed.GetEntity(opt)

            If res.Status = PromptStatus.OK Then
                Dim tr As Transaction = doc.TransactionManager.StartTransaction()
                Using tr
                    Dim obj As DBObject = tr.GetObject(res.ObjectId, OpenMode.ForWrite)
                    AddRegAppTableRecord("KEAN")
                    Dim rb As New ResultBuffer(New TypedValue(1001, "KEAN"), New TypedValue(1000, "This is a test string"))
                    obj.XData = rb
                    rb.Dispose()
                    tr.Commit()
                End Using
            End If
        End Sub


        Shared Sub AddRegAppTableRecord(ByVal regAppName As String)
            Dim doc As Document = Application.DocumentManager.MdiActiveDocument
            Dim ed As Editor = doc.Editor
            Dim db As Database = doc.Database

            Dim tr As Transaction = doc.TransactionManager.StartTransaction()
            Using tr
                Dim rat As RegAppTable = CType(tr.GetObject(db.RegAppTableId, OpenMode.ForRead, False), RegAppTable)
                If Not rat.Has(regAppName) Then
                    rat.UpgradeOpen()
                    Dim ratr As New RegAppTableRecord()
                    ratr.Name = regAppName
                    rat.Add(ratr)
                    tr.AddNewlyCreatedDBObject(ratr, True)
                End If
                tr.Commit()
            End Using
        End Sub


    End Class
End Namespace


原文:http://through-the-interface.typepad.com/throu ... 007/04/adding_xdata_to.html

http://adndevblog.typepad.com/autocad/2012/0 ... -add-and-remove-xdata-.html




[本日志由 tiancao1001 于 2016-10-10 11:16 PM 编辑]


暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:2*4=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©